/*
 *  Copyright 2010 Alexey Frishman (alexey.frishman@gmail.com)
 *  
 *  Licensed under the Apache License, Version 2.0 (the "License"); you may not
 *  use this file except in compliance with the License. You may obtain a copy of
 *  the License at
 *  
 *  http://www.apache.org/licenses/LICENSE-2.0
 *  
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 *  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 *  License for the specific language governing permissions and limitations under
 *  the License.
 * 
 */

package org.json4g.serialization;

import com.google.gwt.json.client.JSONValue;
import com.gwtent.reflection.client.Field;

/**
 * Main interface for all serializers. Because it is tightly coupled with GWT-ENT API, clients may consider using
 * JsonSerializerFacade, which is a wrapper for JsonSerializers with more convenient API. 
 */
public interface JsonSerializer {
    JSONValue serialize(Object object);

    Object deserialize(JSONValue json, Field field);

    boolean supports(Object object);

    boolean supports(JSONValue json, Field field);

}
