/*
 *  Copyright 2010 Alexey Frishman (alexey.frishman@gmail.com)
 *  
 *  Licensed under the Apache License, Version 2.0 (the "License"); you may not
 *  use this file except in compliance with the License. You may obtain a copy of
 *  the License at
 *  
 *  http://www.apache.org/licenses/LICENSE-2.0
 *  
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 *  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 *  License for the specific language governing permissions and limitations under
 *  the License.
 * 
 */

package org.json4g.serialization.parameterized;

import java.util.ArrayList;
import java.util.Collection;
import java.util.LinkedList;
import java.util.List;

import org.json4g.serialization.JsonSerializer;
import org.json4g.serialization.policy.SerializationPolicy;

import com.gwtent.reflection.client.impl.ClassTypeImpl;

public class JsonListSerializer extends JsonCollectionSerializer {

    public JsonListSerializer(JsonSerializer itemSerializer, SerializationPolicy policy) {
        super(itemSerializer, policy, 
                new ClassTypeImpl(List.class),
                new ClassTypeImpl(ArrayList.class),
                new ClassTypeImpl(LinkedList.class)
        );
    }

    @SuppressWarnings("unchecked")
    @Override
    protected Collection<?> createNewInstance(int size) {
        return new ArrayList(size);
    }

}
