/*
 *  Copyright 2010 Alexey Frishman (alexey.frishman@gmail.com)
 *  
 *  Licensed under the Apache License, Version 2.0 (the "License"); you may not
 *  use this file except in compliance with the License. You may obtain a copy of
 *  the License at
 *  
 *  http://www.apache.org/licenses/LICENSE-2.0
 *  
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 *  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 *  License for the specific language governing permissions and limitations under
 *  the License.
 * 
 */

package org.json4g.serialization.policy;

import com.gwtent.reflection.client.ClassType;
import com.gwtent.reflection.client.Field;

/**
 * Rules how to map field names between JSON and Java class. Names may be the same in Java and in JSON and may differ.
 */
public interface FieldNamePolicy {
    /**
     * @return name for field, how it should be serialized to JSON
     */
    String getNameForField(Field javaField);

    /**
     * @param javaClass
     *            which class to look for the field at
     * @param jsonFieldName
     *            field name from JSON
     * @return Java field in the given Java class, which corresponds to the given JSON field name
     */
    Field getFieldByName(ClassType javaClass, String jsonFieldName);
}
