/*
 *  Copyright 2010 Alexey Frishman (alexey.frishman@gmail.com)
 *  
 *  Licensed under the Apache License, Version 2.0 (the "License"); you may not
 *  use this file except in compliance with the License. You may obtain a copy of
 *  the License at
 *  
 *  http://www.apache.org/licenses/LICENSE-2.0
 *  
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 *  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 *  License for the specific language governing permissions and limitations under
 *  the License.
 * 
 */

package org.json4g.serialization.policy;

/**
 * Rules to customize serialization/deserialization process
 */
public class SerializationPolicy {
    private FieldSerializationCondition fieldCondition;
    private GenericTypeExtractor genericTypeExtractor;
    private FieldNamePolicy fieldNamePolicy;

    public SerializationPolicy(FieldSerializationCondition fieldCondition, GenericTypeExtractor genericTypeExtractor,
            FieldNamePolicy fieldNamePolicy) {
        this.fieldCondition = fieldCondition;
        this.genericTypeExtractor = genericTypeExtractor;
        this.fieldNamePolicy = fieldNamePolicy;
    }

    public FieldSerializationCondition getFieldCondition() {
        return fieldCondition;
    }

    public GenericTypeExtractor getGenericTypeExtractor() {
        return genericTypeExtractor;
    }

    public FieldNamePolicy getFieldNamePolicy() {
        return fieldNamePolicy;
    }

}
